                .286

IODELAY         MACRO
                JMP     SHORT $+2               ; delay for I/O
		JMP	SHORT $+2		; delay for I/O
                ENDM

CODE            SEGMENT BYTE PUBLIC
                ASSUME  CS:CODE,DS:CODE

                ORG     0

DEVICE_DATA     PROC    FAR
NEXT_DEV        DD      -1
ATTRIBUTES      DW      8000H
P_STRATEGY      DW      OFFSET STRATEGY
P_INTERRUPT     DW      OFFSET INTERRUPT
DEV_NAME        DB      'FIXROM  '
RH_OFF          DW      ?
RH_SEG          DW      ?
                DB      0
MSG             DB      'Fix Award dated 18-8-95 ROM BIOS for SiS471 chipset'
                DB      ' by V.Lidovski VI-1996',13,10,'$'
DEVICE_DATA     ENDP

STRATEGY        PROC    FAR
                MOV     CS:RH_OFF,BX
                MOV     CS:RH_SEG,ES
                RETF
STRATEGY        ENDP

INTERRUPT       PROC    FAR
                PUSHA

                PUSH    CS
                POP     DS

                LES     DI,DWORD PTR RH_OFF
                MOV     BL,ES:[DI+2]
                MOV     AX,8003H
                OR      BL,BL
                JNZ     L2

                LEA     DX,MSG
                MOV     AH,9
                INT     21H

                MOV     CL,53H
                CALL    IN471
                OR      AH,40H
                CALL    OUT471
                MOV     BX,0F000H
                MOV     DS,BX
                MOV     BX,0C008H       ; OR  AL,AL
                MOV     DS:[9288H],BX

                PUSH    AX
                PUSH    CX
                CALL    FLUSHC
                POP     CX
                POP     AX

                AND     AH,0BFH
                CALL    OUT471

                MOV     WORD PTR ES:[DI+0EH],0
                MOV     ES:[DI+10H],CS
                MOV     AX,100H
L2:             MOV     ES:[DI+3],AX
                POPA
                RETF
INTERRUPT       ENDP

FLUSHC          PROC    NEAR
                MOV     DL,8            ; CLEAR UP TO 512KB CACHE RAM
                SUB     BX,BX
L1:             MOV     DS,BX
                SUB     SI,SI
                MOV     CX,0FFFFH
                REP     LODSB
                ADD     BH,10H
                DEC     DL
                JNZ     L1
                RETN
FLUSHC          ENDP

                INCLUDE 471IO.INC

CODE            ENDS

                END
