USES DOS;
CONST
 dhex:string[16]='0123456789ABCDEF';
TYPE
 str7=string[31];
(*
UM498 chipset tester by V. Lidovski
commands are:
 o [filename]    - write to file all registers value
 q               - quit
 r [reg] [value] - read the register value
 ra              - read all registers values
 tum             - test upper memory
 w [reg] [value] - write value to the register
*)
VAR
 b,ADDRESS,value:byte;
 i,j,w:word;
 s:str7;
 f:text;

{$L io498.obj}
{$F+}
procedure in498;external;
procedure out498;external;
{$F-}
FUNCTION hex(n:byte):str7;
 begin
  hex:=dhex[n div 16 +1]+dhex[n mod 16 +1]
 end;

function whex(w:word):str7;
 begin
  whex:=hex(hi(w))+hex(lo(w))
 end;

begin
 repeat
  readln(s);
  if s[1]='w' then
   begin
    val(copy(s,3,2),address,i);
    val(copy(s,6,length(s)-5),value,i);
    out498
   end
  else if s='q'
        then
         exit
        else if s='ra' then
              begin
               b:=0;
               write('00: ');
               for address:=0 to 63 do
                begin
                 inc(b);
                 in498;
                 write(hex(value),' ');
                 if b mod 10 = 0 then
                  begin
                   writeln;
                   write(b,': ')
                  end
                end;
                writeln
               end
             else if s[1]='o' then
                   begin
                    assign(f,copy(s,3,length(s)-2));
                    rewrite(f);
                    b:=0;
                    for address:=0 to 63 do
                     begin
                      inc(b);
                      in498;
                      s:=hex(value)+' ';
                      write(f,s);
                      if b mod 10 = 0 then writeln(f)
                     end;
                    writeln(f);
                    close(f)
                   end
                  else
                   if s='tum' then
                    begin
                     w:=$c000;
                     for b:=0 to 11 do
                      begin
                       i:=memw[w:0];
                       memw[w:0]:=$7777;
                       j:=memw[w:0];
                       memw[w:0]:=i;
                       writeln(whex(w):5,whex(i):7,whex(j):7);
                       w:=w+$400
                      end
                    end
                   else
                    begin
                     val(copy(s,3,2),address,i);
                     in498;
                     writeln(hex(value))
                    end
 until false
end.
